## enamelpin-by-suricrasiaonline 1.0+git20200705

=== Makefile ===
OBJDIR := obj
BINDIR := bin
SRCDIR := rt
TESTDIR:= test

NASM ?= nasm

BITS ?= $(shell getconf LONG_BIT)

# -mpreferred-stack-boundary=3 messes up the stack and kills SSE!
#COPTFLAGS=-Os -fvisibility=hidden -fwhole-program -fno-plt \
#  -ffast-math -funsafe-math-optimizations -fno-stack-protector -fomit-frame-pointer \
#  -fno-exceptions -fno-unwind-tables -fno-asynchronous-unwind-tables

COPTFLAGS=-Os -fno-plt -fno-stack-protector -fno-stack-check -fno-unwind-tables \
  -fno-asynchronous-unwind-tables -fomit-frame-pointer -ffast-math -no-pie \
  -fno-pic -fno-PIE -ffunction-sections -fdata-sections -fno-plt \
  -fmerge-all-constants -mno-fancy-math-387 -mno-ieee-fp
CXXOPTFLAGS=$(COPTFLAGS) -fno-exceptions \
  -fno-rtti -fno-enforce-eh-specs -fnothrow-opt -fno-use-cxa-get-exception-ptr \
  -fno-implicit-templates -fno-threadsafe-statics -fno-use-cxa-atexit

CFLAGS=-Wall -Wextra -Wpedantic -std=gnu11 -nostartfiles -fno-PIC $(COPTFLAGS) #-DUSE_DL_FINI
CXXFLAGS=-Wall -Wextra -Wpedantic -std=c++11 $(CXXOPTFLAGS) -nostartfiles -fno-PIC

CFLAGS   += -m$(BITS) $(shell pkg-config --cflags sdl2)
CXXFLAGS += -m$(BITS) $(shell pkg-config --cflags sdl2)

ifeq ($(BITS),32)
# I think prescott is basically nocona but 32-bit only, althought I'm not sure
# if this one is optimal
CFLAGS += -march=prescott
else
# I've heard nocona gets slightly smaller binaries than core2
CFLAGS += -march=nocona
endif

LIBS = $(filter-out -pthread,$(shell pkg-config --libs sdl2)) -lX11 -lc #-lGL

PWD ?= .

SMOLFLAGS = --smolrt "$(PWD)/rt" --smolld "$(PWD)/ld" \
     -falign-stack -fuse-interp \
     --verbose #--keeptmp
# -fuse-dnload-loader -fskip-zero-value -fuse-nx -fskip-entries -fuse-dt-debug
# -fuse-dl-fini -fno-start-arg -funsafe-dynamic

PYTHON3 ?= python3

all: $(BINDIR)/hello-crt $(BINDIR)/sdl-crt $(BINDIR)/flag $(BINDIR)/hello-_start

clean:
	@$(RM) -vrf $(OBJDIR) $(BINDIR)

%/:
	@mkdir -vp "$@"

.SECONDARY:

$(OBJDIR)/%.lto.o: $(SRCDIR)/%.c $(OBJDIR)/
	$(CC) -flto $(CFLAGS) -c "$<" -o "$@"
$(OBJDIR)/%.lto.o: $(TESTDIR)/%.c $(OBJDIR)/
	$(CC) -flto $(CFLAGS) -c "$<" -o "$@"

$(OBJDIR)/%.o: $(SRCDIR)/%.c $(OBJDIR)/
	$(CC) $(CFLAGS) -c "$<" -o "$@"
$(OBJDIR)/%.o: $(TESTDIR)/%.c $(OBJDIR)/
	$(CC) $(CFLAGS) -c "$<" -o "$@"

$(BINDIR)/%: $(OBJDIR)/%.o $(BINDIR)/
	$(PYTHON3) ./smold.py $(SMOLFLAGS) $(LIBS) "$<" "$@"
	$(PYTHON3) ./smoltrunc.py "$@" "$(OBJDIR)/$(notdir $@)" && mv "$(OBJDIR)/$(notdir $@)" "$@" && chmod +x "$@"

$(BINDIR)/%-crt: $(OBJDIR)/%.lto.o $(OBJDIR)/crt1.lto.o $(BINDIR)/
	$(PYTHON3) ./smold.py $(SMOLFLAGS) --ldflags=-Wl,-Map=$(BINDIR)/$*-crt.map $(LIBS) "$<" $(OBJDIR)/crt1.lto.o "$@"
	$(PYTHON3) ./smoltrunc.py "$@" "$(OBJDIR)/$(notdir $@)" && mv "$(OBJDIR)/$(notdir $@)" "$@" && chmod +x "$@"

.PHONY: all clean

=== debian/changelog ===
enamelpin-by-suricrasiaonline (1.0+git20200705-0ddebs1~ubuntu24.04) noble; urgency=medium

  * Initial release.

 -- Nicolas HOUDELOT <nicolas@demosdebs.org>  Thu, 08 May 2025 17:34:52 +0200

=== debian/control ===
Source: enamelpin-by-suricrasiaonline
Section: demos
Priority: optional
Maintainer: Nicolas HOUDELOT <nicolas@demosdebs.org>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 pkgconf,
 shader-minifier:native,
 nasm,
 libgtk-3-dev,
 libglu-dev,
 pax-utils,
 python3-minimal
Standards-Version: 4.6.2
Homepage: https://www.pouet.net/prod.php?which=86206

Package: enamelpin-by-suricrasiaonline
Architecture: amd64
Multi-Arch: foreign
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: 4k executable graphics by Suricrasia Online, released in 2020
 4k executable graphics demo designed for 64-bit Linux systems.
 Enamel Pin was awarded first place at Solskogen 2020 in the 4k procedural
 graphics category.

=== debian/rules ===
#!/usr/bin/make -f

export PKG_CONFIG_PATH=/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --no-parallel

override_dh_builddeb:
	dh_builddeb -- -Zxz

=== debian/watch ===
version=4
opts="mode=git, pgpmode=none,pretty=1.0+git%cd, \
         repack,compression=xz" \
         https://github.com/Suricrasia-Online/Enamel-Pin \
         HEAD debian uupdate
